using System;
using System.Threading;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using OpenQA.Selenium;
using OpenQA.Selenium.Chrome;
using OpenQA.Selenium.Support.UI;

namespace CalculatorSeleniumTest
{
    [TestClass]
    public class UnitTest1
    {
        static string DriverDirectory = "C:\\webDrivers";
        static string URL = "file:///D:/VSCode/Vue3/CalculatorExtended/index.html";
        //const string URL = "http://localhost:3000/"; //"https://hehocalculator.azurewebsites.net/"
        static IWebDriver driver = new ChromeDriver(DriverDirectory);
        static IWebElement num1Element;
        static IWebElement num2Element;
        static IWebElement num3Element;
        static IWebElement num4Element;
        static IWebElement num5Element;
        static IWebElement num6Element;
        static IWebElement num7Element;
        static IWebElement num8Element;
        static IWebElement num9Element;
        static IWebElement num0Element;

        static IWebElement oprAddElement;
        static IWebElement oprSubElement;
        static IWebElement oprDivElement;
        static IWebElement oprMulElement;
        static IWebElement oprDotElement;
        static IWebElement oprCalcElement;

        static IWebElement resultElement;
        static IWebElement clearElement;

        [ClassInitialize]
        public  static void TestClassSetUp(TestContext context)
        {
            driver.Navigate().GoToUrl(URL);
            num1Element = driver.FindElement(By.Id("num1"));
            num2Element = driver.FindElement(By.Id("num2"));
            num3Element = driver.FindElement(By.Id("num3"));
            num4Element = driver.FindElement(By.Id("num4"));
            num5Element = driver.FindElement(By.Id("num5"));
            num6Element = driver.FindElement(By.Id("num6"));
            num7Element = driver.FindElement(By.Id("num7"));
            num8Element = driver.FindElement(By.Id("num8"));
            num9Element = driver.FindElement(By.Id("num9"));
            num0Element = driver.FindElement(By.Id("num0"));

            oprAddElement = driver.FindElement(By.Id("oprAdd"));
            oprSubElement = driver.FindElement(By.Id("oprSub"));
            oprDivElement = driver.FindElement(By.Id("oprDiv"));
            oprMulElement = driver.FindElement(By.Id("oprMul"));
            oprDotElement = driver.FindElement(By.Id("oprDot"));
            oprCalcElement = driver.FindElement(By.Id("oprCalc"));

            resultElement = driver.FindElement(By.Id("result"));
            clearElement = driver.FindElement(By.Id("clear"));
        }

        [TestInitialize]
        public void TestInitialize()
        {
            clearElement.Click();
        }

        [TestMethod]
        public void TestAdd()
        {
            Thread.Sleep(1000);
            num1Element.Click();
            Thread.Sleep(1000);
            oprAddElement.Click();
            Thread.Sleep(1000);
            num1Element.Click();
            Thread.Sleep(1000);
            oprCalcElement.Click();
            Thread.Sleep(3000);

            
            double result = Double.Parse(resultElement.Text);
            Assert.AreEqual(2, result);
        }

        [TestMethod]
        public void TestDiv()
        {
            Thread.Sleep(1000);
            num2Element.Click();
            Thread.Sleep(1000);
            num1Element.Click();
            Thread.Sleep(1000);
            oprDivElement.Click();
            Thread.Sleep(1000);
            num3Element.Click();
            Thread.Sleep(1000);
            oprCalcElement.Click();
            Thread.Sleep(3000);


            double result = Double.Parse(resultElement.Text);
            Assert.AreEqual(7, result);
        }

        [ClassCleanup]
        public static void TestTearDown()
        {
            driver.Quit();
        }
    }
}
